# -*- coding: utf-8 -*-

import os, sys
import ConfigParser

class NotConfigured(Exception):
    def __init__(self, filename):
        self.filename = filename
    def __str__(self):
        return """Program not yet configured! Edit the file

   %s

using some text editor""" % self.filename
            
class Settings(object):
    SETTINGS_DIR = os.path.abspath(os.path.expanduser("~/.feeds"))
    DEFAULT_USER = "YourGoogleLogin@gmail.com"
    DEFAULT_PWD = "YourGooglePassword"

    def __init__(self, dir = SETTINGS_DIR):
        self._dir = dir
        self._ini_file = os.path.join(self._dir, "feeds.ini")
        self._org_file = os.path.join(self._dir, "feeds.txt")
        self._load_config()

    def google_auth(self):
        return self._google_auth
    def org_file(self):
        return self._org_file

    def _load_config(self):
        """
        Otwiera plik z danymi konfiguracyjnymi i wczytuje je
        """
        if not os.path.exists(self._dir):
            os.mkdir(self._dir)
        if not os.path.exists(self._ini_file):
            f = file(self._ini_file, "w")
            f.write("""
[google-auth]
login = %s
password = %s

[files]
feeds_file = %s
""" % (self.DEFAULT_USER, self.DEFAULT_PWD, self._org_file))
            f.close()
            raise NotConfigured(self._ini_file)

        self.config = ConfigParser.ConfigParser({ 
            'here' : self._dir })
        self.config.read(self._ini_file)

        self._google_auth = dict(
            login = self.config.get('google-auth', 'login'),
            password = self.config.get('google-auth', 'password'),
        )
        self._org_file = self.config.get('files', 'feeds_file')

        if (self._google_auth['login'] == self.DEFAULT_USER) or \
           (self._google_auth['password'] == self.DEFAULT_PWD):
            raise NotConfigured(self._ini_file)

