# -*- coding: utf-8 -*-

"""
Wybrane elementy klienta PostRank
"""

import urllib, urllib2
import re
import simplejson
import time

import logging
log = logging.getLogger("postrank")

POSTRANK = 'http://api.postrank.com/v1/'

class PostRankClient(object):
    """
    A few PostRank functions
    """

    def __init__(self, appkey):
        """
        appkey to identyfikator aplikacji, np. domeny
        """
        self.appkey = appkey

    def feed_info(self, feed_url):
        """
        Dla zadanego feedu zwraca podstawowe informacje na jego temat.
        
        Uwaga: funkcja zwykle zwraca rozbudowany słownik ale może
        zwrócić None gdy dostanie błąd HTTP 202 (co sygnalizuje, że
        kiedyś się pojawi...)
        """

        query = {
            'appkey' : self.appkey,
            'format' : 'json',
            'id' : feed_url,
            }
        enc_query = urllib.urlencode(query)

        url = "http://api.postrank.com/v2/feed/info?" + enc_query

        request = urllib2.Request(url.encode('utf-8'))

        log.info("Calling: %s" % request.get_full_url())
        try:
            f = urllib2.urlopen(request)
        except urllib2.HTTPError, e:
            if e.code == 202:
                log.info("HTTP:202 (accepted) - feed accepted for processing")
                return None
            else:
                raise
        result = f.read()
        log.debug("Result: %s" % result)

        return simplejson.loads(result)

